/*
 * @(#)adm8511reg.h	1.1 06/01/22
 * Register dehinitsions of ADMtek ADM8511 Fast Ethernet to USB controller.
 * Codeded by Masayuki Murayama(KHF04453@nifty.ne.jp)
 * This file is public domain.
 */

#define	ECTRL0		0x00	/* B */
#define	ECTRL1		0x01	/* B */
#define	ECTRL2		0x02	/* B */
#define	MCAST		0x08	/* 8byte array */
#define	ETHERNETID	0x10	/* B */
#define	PAUSE		0x18	/* B */
#define	RNFLOW		0x1a	/* B */
#define	RFFLOW		0x1b	/* B */
#define	EPICTRL		0x1c	/* B */
#define	RXCTRL		0x1d	/* B */
#define	BIST		0x1e	/* B */
#define	EEOFFSET	0x20	/* B */
#define	EEDATA		0x21	/* W */
#define	EECTRL		0x23	/* B */
#define	PHYADDR		0x25	/* B */
#define	PHYDATA		0x26 	/* W */
#define	PHYCTRL		0x28	/* B */
#define	USBSTAT		0x2a	/* B */
#define	ETHTXSTAT	0x2b	/* W */
#define	ETHRXSTAT	0x2d	/* B */
#define	LOSTCNT		0x2e	/* W */
#define	WF0MASK		0x30	/* 16byte array */
#define	WF0OFFSET	0x40	/* W */
#define	WF0CRC		0x41	/* W */
#define	WF1MASK		0x48	/* 16byte array */
#define	WF1OFFSET	0x58	/* W */
#define	WF1CRC		0x59	/* W */
#define	WF2MASK		0x60	/* 16byte array */
#define	WF2OFFSET	0x70	/* W */
#define	WF2CRC		0x71	/* W */
#define	WCTRL		0x78	/* B */
#define	WSTAT		0x7a	/* B */
#define	IPHY		0x7b	/* B */
#define	GPIO54		0x7c	/* B */
#define	GPIO10		0x7e	/* B */
#define	GPIO32		0x7f	/* B */
#define	TEST		0x80	/* B */
#define	TESTMODE	0x81	/* B */

/* Ethernet control register 0: offset 0 */
#define	ECTRL0_TX	0x80
#define	ECTRL0_RX	0x40
#define	ECTRL0_RX_FLOW	0x20
#define	ECTRL0_WAKEON	0x10
#define	ECTRL0_RXSTAT	0x08
#define	ECTRL0_NO_BOFF	0x04
#define	ECTRL0_ALLMULTI	0x02
#define	ECTRL0_CRC	0x01

#define	ECTRL0_BITS	\
	"\020"	\
	"\010TX"	\
	"\007RX"	\
	"\006RXFLOW"	\
	"\005WAKEON"	\
	"\004RXSTAT"	\
	"\003NO_BOFF"	\
	"\002ALLMULTI"	\
	"\001CRC"

/* Ethernet control register 1: offset 1 */
#define	ECTRL1_RX_FLOW	0x80
#define	ECTRL1_DELAY	0x40
#define	ECTRL1_FDPX	0x20
#define	ECTRL1_100M	0x10
#define	ECTRL1_RESET	0x08
#define	ECTRL1_HOMELAN	0x04

#define	ECTRL1_BITS	\
	"\020"	\
	"\010RXFLOW"	\
	"\007DELAY"	\
	"\006FDPX"	\
	"\005100M"	\
	"\004RESET"	\
	"\003HOMELAN"

/* Ethernet control register 2: offset 2 */
#define	ECTRL2_LDEEPROM	0x20
#define	ECTRL2_EEWREN	0x10
#define	ECTRL2_LOOPBK	0x08
#define	ECTRL2_PROMISC	0x04
#define	ECTRL2_RXBAD	0x02
#define	ECTRL2_EP3RDCLR	0x01

#define	ECTRL2_BITS	\
	"\020"	\
	"\010LDEEPROM"	\
	"\005EEWREN"	\
	"\004LOOPBK"	\
	"\003PROMISC"	\
	"\002RXBAD"	\
	"\001EP3RDCLR"
/* Recieve Packet number based Flow Control register: offset 1a */
#define	RNFLOW_PKTNO	0x7e	/* */
#define	RNFLOW_PKTNO_SHIFT	1
#define	RNFLOW_EN	0x01	/* enable rx flow control */

/* Occupied Recieve FIFO based Flow Control register: offset 1b */
#define	RFFLOW_RXSIZE	0x7e	/* */
#define	RFFLOW_RXSIZE_SHIFT	1
#define	RFFLOW_RXSIZE_UNIT	1024
#define	RFFLOW_EN	0x01	/* enable rx flow control */

/* Rx FIRO Control register: offset 0x1d */
#define	RXFIFO_EXT_SRAM	0x02	/* enable external 32k sram */
#define	RXFIFO_RX32PKT	0x01	/* max 32 packet */

/* EP1 control register: offset 0x1c */
#define	EP1CTRL_SEND0	0x80
#define	EP1CTRL_ITVLA	0x60
#define	EP1CTRL_ITVLB	0x1f

/* EEPROM offset register: offset 0x20 */
#define	EEOFFSET_MASK	0x3f	/* eeprom offset address in word */

/* EEPROM access control register: offset 0x23 */
#define	EECTRL_DONE	0x04
#define	EECTRL_RD	0x02
#define	EECTRL_WR	0x01

#define	EECTRL_BITS	\
	"\020"	\
	"\003DONE"	\
	"\002RD"	\
	"\001WR"

/* PHY control register: offset 28 */
#define	PHYCTRL_DONE	0x80
#define	PHYCTRL_RD	0x40
#define	PHYCTRL_WR	0x20
#define	PHYCTRL_ADDR	0x1f	/* PHY address */

#define	PHYCTRL_BITS	\
	"\020"	\
	"\010DONE"	\
	"\007RD"	\
	"\006WR"

/* Internal PHY control register: offset 7b */
#define	IPHY_EN		0x02
#define	IPHY_RST	0x01

#define	IPHY_BITS	\
	"\020"	\
	"\002EN"	\
	"\001RST"

/* GPIO45 register: offset 7c */
#define	GPIO54_5OE	0x20
#define	GPIO54_5O	0x10
#define	GPIO54_5I	0x08
#define	GPIO54_4OE	0x04
#define	GPIO54_4O	0x02
#define	GPIO54_4I	0x01

/* GPIO01 register: offset 7e */
#define	GPIO10_1OE	0x20
#define	GPIO10_1O	0x10
#define	GPIO10_1I	0x08
#define	GPIO10_0OE	0x04
#define	GPIO10_0O	0x02
#define	GPIO10_0I	0x01

/* GPIO23 register: offset 7f */
#define	GPIO32_3OE	0x20
#define	GPIO32_3O	0x10
#define	GPIO32_3I	0x08
#define	GPIO32_2OE	0x04
#define	GPIO32_2O	0x02
#define	GPIO32_2I	0x01

/* rx status at the end of received packets */
/* byte 0 and 1 is packet length in little endian */
/* byte 2 is receive status */
#define	RSR_DRIBBLE	0x10
#define	RSR_CRC		0x08
#define	RSR_RUNT	0x04
#define	RSR_LONG	0x02
#define	RSR_MULTI	0x01

#define	RSR_ERRORS	\
	(RSR_DRIBBLE | RSR_CRC | RSR_RUNT | RSR_LONG | RSR_MULTI)

#define	RSR_BITS	\
	"\020"	\
	"\005DRIBBLE"	\
	"\004CRC"	\
	"\003RUNT"	\
	"\002LONG"	\
	"\001MULTI"
/* byte 3 is reserved */
